'FFSubmenu=Bilderlisten
'FFName=Duplikate lschen

' ********************************************************************
' DoubleDelete.vbs (Skript fr FixFoto)
' Funktion:	Skript zum Lschen von Duplikaten in Bilderlisten
'
' Copyright Harald Maeckler, Dsseldorf 2013 - 2016
'
' Version 1.05 vom 29.03.2016 - Skript-URL gem Forenberarbeitung gendert
' Version 1.04 vom 20.03.2013	- 'Abbruch' ersetzt durch 'Beenden'
'								- im Protokoll wird die jeweilige Duplikatsanzahl angegeben
' Version 1.03 vom 19.03.2013	- Ordner DoubleDelete im zip-Archiv gefllt
'								- Rechtschreibfehler in den Tooltips beseitigt
' Version 1.02 vom 19.03.2013	- Protokollfhrung ber gelschte Duplikate
' Version 1.01 vom 18.03.2013	- Darstellung der Kurzbeschreibung gendert
'								- nach Lschen in ausgewhlter Liste wird
'									das Skript nicht mehr automatisch beendet
'								- 'Ausgewhlte Liste anzeigen' hinzugefgt
'									(Vorraussetzung: mindestens FF 3.40.70)
'								- Lschalgorithmus gendert
' Version 1.00 vom 16.03.2013	- Betaversion
' ********************************************************************

'** Start Text **
'
' DoubleDelete
' =========
' Mit dem Skript knnen Duplikate in einer ausgewhlten Bilderliste oder in allen
' Bilderlisten aufgesprt und entfernt werden. Bei der Suche in allen Listen werden
' die Duplikate nicht listenbergreifend gesucht, sondern nacheinander jeweils in
' einer Liste.
'
' Wird das Skript bei festgehaltener Shift-Taste gestartet, erfolgt sofort die Dup-
' likatssuche in allen Bilderlisten ohne Anzeige des Skriptdialogs.
'
' Ab der FixFoto-Version 3.40 B70 kann mit dem Befehl 'Liste anzeigen' die ausge-
' whlte Liste aufgerufen werden.
'
' Bei jeder Bereinigung wird Protokoll ber die gelschten Duplikate gefhrt. Dieses
' kann ber den Button 'Protokoll' aufgerufen und bei Bedarf ausgedruckt werden.
'
' Update
' =====
' Nach Bettigung der Taste 'Update' wird auf der Downloadseite des Skripts ber-
' prft, ob eine neuere Version vorliegt. Ist dies der Fall, wird angeboten die Down-
' loadseite aufzurufen.
'
' Deinstallation
' =========
' Wird die Entfernung des Skripts gewnscht, kann mit der Tastenkombination
' Alt + D eine Lschroutine aufgerufen werden. Nach einer Sicherheitsabfrage wird
' berprft, ob das zugehrige zip-Archiv im Skriptordner abgelegt ist. Wenn ja,
' wird vor dem Lschen angeboten, davon eine Sicherheitskopie an einem whl-
' barem Speicherort abzulegen. Dann wird die Skriptdatei gelscht und die Datei
' FixFotoScript.ini bereinigt.
'
' Nach manueller Durchfhrung der 'Automatischen Skriptkonfiguration' ist das
' Skript mit allen Komponenten aus der FixFoto-Umgebung entfernt.
'
'
' Benutzung des Skripts auf eigene Gefahr!
'
'  Harald Maeckler
'** Textende **

Option Explicit

'Skriptname
Dim SkriptName
const Skript = "DoubleDelete"

'Updatekonstanten und Variable
const SkriptVersion = "1.05"
const SkriptURL = "http://www.ffsf.de/resources/duplikate-loeschen.148/"
Dim UrlVersion,UrlV_Zahl,SkriptV_Zahl,SkriptEnde

'Objekte und Konstante
Dim objFS,WshShell
Dim Text,LaengeMax
Const ForReading = 1, ForWriting = 2, ForAppending = 8

'Lschroutine
Dim TempFile,SkriptKill	 : SkriptKill = false

'Allgemeine Deklarationen
Dim Anzeige,Antwort,Abbruch : Abbruch = false
const azt = 2	'Anzeigezeit in sec.
Dim ListArray,element,anzD,Prot_Datei,Pdatei
'------------------------------------------------------------------------
call Main

Set objFS = nothing
Set WshShell = nothing
'------------------------------------------------------------------------
Sub Main

on error resume next							'Kontrolle ob Skript in FF-Umgebung gestartet wurde
	FF_GetScriptPath
 	if Err.Number > 0 then
		msgbox "Das Skript funktioniert nur in der Programmumgebung von FixFoto!",vbCritical,"Abbruch"
		exit sub
	end if
on error goto 0

Set objFS = CreateObject("Scripting.FileSystemObject")
Set WshShell = CreateObject("WScript.Shell")

if objFS.FileExists(FF_GetScriptPath & "\" & Skript & ".vbs") then
	SkriptName = Skript & ".vbs"
elseif objFS.FileExists(FF_GetScriptPath & "\" & Skript & ".vbe") then
	SkriptName = Skript & ".vbe"
else
	msgbox "Das Skript wurde umbenannt!",vbCritical,"Abbruch"
	exit sub
end if

Prot_Datei = FF_GetScriptPath() & "\MeckiScript\DoubleDelete\DoubleDelete_Protokoll.txt"

if FF_GetAsyncKeyState(16) then		'Taste Shift wird festgehalten
	call DeleteSchleife (true)
	exit sub
end if

'** Start Dialog Duplikate lschen **
FF_AddDialog "Duplikate lschen",161,95
FF_AddControl "Duplikate lschen","Bilderlisten","GROUP",5,5,150,70
FF_AddControl "Duplikate lschen","Beenden","BUTTON",122,80,33,11
FF_AddControl "Duplikate lschen","&delete","BUTTON",18,18,1,1
FF_AddControl "Duplikate lschen","|","STATIC",18,80,22,11
FF_SetControlStyle "Duplikate lschen","|",1
FF_AddControl "Duplikate lschen","Liste","COMBO",11,16,138,10
FF_AddControl "Duplikate lschen","?","BUTTON",5,80,11,11
FF_AddControl "Duplikate lschen","Update","BUTTON",42,80,33,11
FF_AddControl "Duplikate lschen","Duplikate in der gewhlten Liste lschen","BUTTON",18,31,118,11
FF_AddControl "Duplikate lschen","Duplikate in allen Bilderlisten lschen","BUTTON",18,44,118,11
FF_AddControl "Duplikate lschen","Liste anzeigen","BUTTON",110,60,40,11
FF_AddControl "Duplikate lschen","Protokoll","BUTTON",79,80,40,11
'** End Dialog Duplikate lschen **

ListArray = split(FF_IListGetLists,vbNewLine)
for each element in ListArray
	FF_SetControl "Duplikate lschen","Liste",element
next

for each element in ListArray
	if FF_IListGetCurrentList = element then
		FF_SetControl "Duplikate lschen","Liste",element
		exit for
	end if
next

'Tooltips
if Version_OK("3.30.06") then
	FF_SetControlTooltip "Duplikate lschen","Duplikate in der gewhlten Liste lschen", "" &_
						 "In der ausgewhlten Liste wird nach Duplikaten gesucht." & vbNewLine & _
						 "Werden welche gefunden, werden sie gelscht."
	FF_SetControlTooltip "Duplikate lschen","Duplikate in allen Bilderlisten lschen", "" &_
						 "In allen Bilderlisten wird nach Duplikaten gesucht." & vbNewLine & _
						 "Werden welche gefunden, werden sie gelscht."
	FF_SetControlTooltip "Duplikate lschen","Liste anzeigen", "" &_
						 "Die ausgewhlte Liste wird angezeigt"
	FF_SetControlTooltip "Duplikate lschen","?", "" &_
						 "Anzeige der Kurzbeschreibung"
	FF_SetControlTooltip "Duplikate lschen","Update", "" &_
						 "Prfung ob eine neue Version vorliegt"
	FF_SetControlTooltip "Duplikate lschen","Protokoll", "" &_
						 "Anzeige des zuletzt angelegten Protokolls"
	FF_SetControlTooltip "Duplikate lschen","Beenden", "" &_
						 "Das Skript wird beendet"
end if

if not Version_OK("3.40.70") then FF_EnableControl "Duplikate lschen","Liste anzeigen",false
if Version_OK("3.40.52") then FF_SetTooltipDelay 3000
FF_ActivateControl "Duplikate lschen","&delete"
FF_SetDialogTimer "Duplikate lschen", 100

Do
	Select Case FF_ShowDialog ("Duplikate lschen")
	Case "TIMER"
		FF_SetControl "Duplikate lschen" ,"|", "V " & Skriptversion
		FF_SetDialogTimer "Duplikate lschen", 0
	Case "&delete"
		Antwort = msgbox("Soll das Skript " & objFS.GetFileName(Skriptname) & vbNewline & _
						 "wirklich gelscht werden?", _
						 vbYesNo + vbQuestion,"Sicherheitsabfrage")
		if Antwort = vbYes then
			SkriptKill = true
			exit do
		end if
	Case "Duplikate in der gewhlten Liste lschen"
		anzD = 0
		call DeleteSchleife (false)
	Case "Duplikate in allen Bilderlisten lschen"
		anzD = 0
		call DeleteSchleife (true)
	Case "Liste anzeigen"
		FF_IListShow FF_GetControl("Duplikate lschen","Liste")		
	Case"?"
		call TextErmittlung ("'** Start Text **","'** Textende **")
		call TextAnzeige (LaengeMax * 2.6,200)
		'WshShell.Popup Text,,"Kurzbeschreibung"
	Case"Update"
		SkriptEnde = false
		call Update
		if SkriptEnde then exit do
	Case "Protokoll"
		if objFS.FileExists(Prot_Datei) then
			WshShell.Run "notepad " + Prot_Datei,1,false
		else
			msgbox "Es wurde noch keine Protokolldatei erstellt!",vbInformation,"Hinweis"
		end if
	Case "Beenden","CANCEL"
		exit do
	Case Else
	End Select
loop

FF_CloseDialog ("Duplikate lschen")

if SkriptKill then call KillSkript

End Sub
'************************************************************************
'************************************************************************
'Prfung der FF-Version
'************************************************************************
Function Version_OK(MinVersion)
dim VersNr

 VersNr=split(MinVersion,".")
 Version_OK=FF_GetMajor * 1000 + FF_GetMinor + FF_GetBuild / 1000 >=_
     		VersNr(0) * 1000 + VersNr(1) + VersNr(2) / 1000

End Function
'************************************************************************
'Lsch-Funktion
'************************************************************************
Sub KillSkript
'Skript mit allen Komponenten entfernen

Dim SPfad
Skriptname = FF_GetScriptPath & "\" & Skriptname

'### FixFotoScript.ini bereinigen
TempFile = FF_GetFFPathEx(1) & "\FixFotoScript.ini"
if objFS.FileExists(TempFile) then
	call IniBereinigung
	if Abbruch then exit sub
else
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht gefunden werden." & vbNewLine & _
			"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	exit sub
end if

'### zip-Archiv auf Wunsch sichern, dann lschen
TempFile = FF_GetScriptPath & "\" & objFS.GetBaseName(Skriptname) & ".zip"
if objFS.FileExists(TempFile) then
	Antwort = msgbox("Soll das Archiv " & objFS.GetBaseName(Skriptname) & ".zip" & _
			 " gesichert werden?",vbYesNo + vbQuestion,"Sicherheitskopie")
	if Antwort = vbYes then
		SPfad = FF_EnterPath(true,"Wo soll die Sicherheitskopie angelegt werden?")
		if SPfad = "" then
			msgbox "Das Lschen des Skripts wird abgebrochen!",vbExclamation,"Hinweis"
			exit sub
		end if
		SPfad = SPfad & "\" & objFS.GetBaseName(Skriptname) & ".zip"
		objFS.CopyFile Tempfile, SPfad, true
	end if
	objFS.DeleteFile TempFile,true
end if

'### Skriptdatei lschen
objFS.DeleteFile Skriptname,true

'### beigepackten Ordner lschen
TempFile = FF_GetScriptPath & "\MeckiScript\DoubleDelete"
if objFS.FolderExists(TempFile) then objFS.DeleteFolder TempFile,true

'### Fertigmeldung
msgbox "Das Skript " & objFS.GetFileName(Skriptname) & vbNewLine & "wurde mit allen Komponenten gelscht!" & vbNewLine & _
	   "Es wird empfohlen die 'Automatische Skriptkonfiguration' aufzurufen.",vbExclamation,"Hinweis"

End Sub
'------------------------------------------------------------------------
Sub IniBereinigung
'FixFotoScript.ini - Bereinigung

Dim Zeile, zNr,Anfang, Ende, DateiTmp, ZielZeile, tmpString

DateiTmp =  FF_GetFFPathEx(1) & "\FixFotoScript.tmp"

'### Wo befindet sich der Eintrag zum Skript?
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if tmpString = "[Script]" then Anfang = zNr
	if tmpString = "File=.\" & objFS.GetFileName(Skriptname) then
		Ende = zNr
		exit do	
	end if
loop 
Zeile.Close

if Ende <= Anfang then
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht bereinigt werden." & vbNewLine & _
		"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	Abbruch = true
	exit sub
end if

'### Zeilen ohne skriptbezogene Zeilen in DateiTmp bertragen
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)
Set ZielZeile  = objFS.CreateTextFile(DateiTmp, True)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if zNr < Anfang or zNr > Ende then
		ZielZeile.WriteLine tmpString
	end if
loop 

Zeile.Close
ZielZeile.Close

'### Umkopieren von DateiTmp nach FixFotoScript.ini (TempFile)
objFS.CopyFile DateiTmp, TempFile, True
objFS.DeleteFile (DateiTmp)

End Sub
'************************************************************************
'Update-Funktion
'************************************************************************
Sub Update
Dim Antwort

call Versionsermittlung_url

if not Abbruch then
	SkriptV_Zahl = Replace(SkriptVersion,".","") *1
	
	if UrlV_Zahl = SkriptV_Zahl then
		msgbox "Die Version " & SkriptVersion & " ist aktuell!",vbInformation,"Versionsmeldung"
	elseif SkriptV_Zahl < UrlV_Zahl then
		Antwort = msgbox("Die Skriptversion " & SkriptVersion & " ist nicht mehr aktuell!" & vbNewLine &_
				"Es steht die Version " & UrlVersion & " zum Download bereit." & vbNewLine & vbNewLine & _
				"Soll die Downloadseite aufgerufen werden?",vbQuestion + vbYesNo,"Versionsmeldung")
		if Antwort = vbYes then
			on error resume next
			WshShell.Run SkriptUrl,1,false
			if err <> 0 then
				msgbox "Die Downloadseite wurde nicht gefunden!",vbExclamation,"Hinweis"
			else
				SkriptEnde = true
			end if
			on error goto 0
		end if
	else
		msgbox 	"Es liegt ein Fehler in den Versionsangaben vor." & vbNewLine &_
				"Die Skriptversion " & SkriptVersion & " ist grer als die auf" & vbNewLine &_
				"der Downloadseite angegebene Version " & UrlVersion & ".",vbInformation,"Fehlermeldung"
	end if
end if

End Sub
'------------------------------------------------------------------------
Sub Versionsermittlung_url

Dim Inhalt,Start,Zeit,pos1,pos2,n
Dim xml, Fehler
Fehler = false

on error resume next
Set xml = CreateObject("Microsoft.XMLHTTP")
xml.Open "Get",SkriptUrl,false
xml.Send

Inhalt = xml.responseText
'WshShell.Popup Inhalt,,"Kurzbeschreibung"
if err > 0 then
	Fehler = true
else
	'Version suchen und anzeigen
	pos1 = instr(Inhalt,"Version:")
'Msgbox pos1
	if pos1 > 0 then
		pos2 = instr(pos1 ,Inhalt,"<br")
		if pos2 > 0 then
			UrlVersion = trim(mid(Inhalt,pos1,pos2-pos1))
			'Msgbox "Aktuell ist die " & UrlVersion,vbInformation,"Information"
		else
			Fehler = true
		end if
	else
		Fehler = true
	end if
end if

Set xml = nothing

if Fehler then
	msgbox  "Die Versionsangabe wurde nicht gefunden!" & vbNewLine &_
			"Mglicherweise funktioniert der Internetaufruf nicht." & vbNewLine & vbNewLine & _
			"Am besten nochmal probieren!",vbExclamation,"Fehlermeldung"
	Abbruch = true
	exit sub
end if

'Version als Zahl
pos1 = instr(UrlVersion," ")
if pos1 = 0 then pos1 = 7
UrlVersion = trim(mid(UrlVersion,pos1+1))
UrlV_Zahl = Replace(UrlVersion,".","") *1

End Sub
'************************************************************************
'Text auslesen
'************************************************************************
Sub TextErmittlung (T_Anfang,T_Ende)
'Text auslesen von T-Anfang bis T-Ende

Dim Skript, Anfang, Ende, Zeile

Set Skript = objFS.OpenTextFile(FF_GetScriptPath & "\" & SkriptName, ForReading, False)

Do While Skript.AtEndOfStream <> True
	Zeile = Skript.ReadLine

	if instr(Zeile,T_Ende) > 0 and Anfang then
		Ende = true
		exit do
	end if

	if Anfang then
		Text = Text & mid(Zeile,2) & vbNewLine
		if len(Zeile) > LaengeMax then LaengeMax = len(Zeile)
	end if

	if instr(Zeile,T_Anfang) > 0 then Anfang = true
Loop

Skript.Close

if not Anfang or not Ende then Text = ""

End Sub
'------------------------------------------------------------------------
Sub TextAnzeige (D_Breite,D_Hoehe)
'Dialog mit EDIT-Steuerelement zur Textanzeige

const ES_READONLY = 2048    	'Stilkonstanten fr EDIT
const WS_VSCROLL = 2097152

const dlg = "Kurzbeschreibung"	'Benennung er Anzeige
 
'Dialog mit Textelement
'Stil: ReadOnly und Vertikal Skrollen, wenn Textblock hher als das Textelement
FF_AddDialog dlg,D_Breite,D_Hoehe
FF_AddControl dlg,"Beschreibung","EDIT",0,0,D_Breite,D_Hoehe-20
FF_SetControlStyle dlg,"Beschreibung", ES_READONLY or WS_VSCROLL
FF_AddControl dlg,"OK","BUTTON",D_Breite/2-15,D_Hoehe-15,30,10

FF_SetControl dlg,"Beschreibung",Text    'Textanzeige

do
	Select Case FF_ShowDialog (dlg)
		Case "OK","CANCEL"
			exit do
	end select
loop

FF_CloseDialog dlg
 
End Sub
'************************************************************************
'************************************************************************
Sub DeleteSchleife (flagAll)
'Listen auswhlen in denen nach Duplikaten gesucht werden sollen

Dim ListeA,msg,AktuelleListe

'Protokolldatei neu anlegen
Set Pdatei = objFS.OpenTextFile(Prot_Datei, ForWriting, true)
Pdatei.Write "DoubleDelete-Protokoll vom " & Now & vbNewline
Pdatei.Close

if not flagAll then
	ListeA = FF_GetControl("Duplikate lschen","Liste")
	if FF_IListGetCount(ListeA) < 2 then
		msgbox 	"Die Liste '" & ListeA & "'" & vbNewLine &_
				"beinhaltet max. ein Bild.",vbInformation,"Hinweis"
		exit sub
	end if
	call Delete (ListeA)
else

	ListArray = split(FF_IListGetLists,vbNewLine)
	for each element in ListArray
		if FF_IListGetCurrentList = element then
			AktuelleListe = element								'aktuelle Liste ermitteln
			exit for
		end if
	next

	for each ListeA in ListArray
		call Delete (ListeA)
	next
	
	if len(AktuelleListe) > 0 then FF_IListUpdate AktuelleListe	'ehemals aktuelle Liste aktualisieren
	
end if

'Schlussmeldung
if not flagAll then
	msg = "In der Liste '" & ListeA & "'" & vbNewLine
else
	msg = "Es wurden alle Bilderlisten berprft." & vbNewLine & "Es "
end if

if anzD = 0 then
	msg = msg & "sind keine Duplikate vorhanden."
else
	msg = msg & "wurde(n) " & anzD & " Duplikat(e) gelscht."
end if
	
msgbox msg,vbInformation,"Schlussmeldung"

End Sub
'------------------------------------------------------------------------
Sub Delete (BListe)
'nach Duplikate in der vorgegebenen Liste suchen und ggf. lschen

Dim Sammlung,SammelArray,DuplikatSammlung,ProtText
Dim anzDbl : anzDbl = 0

'Bilder ohne die Duplikate sammeln und Liste lschen 
do while FF_IListGetCount(BListe) > 0
	if instr(Sammlung,FF_IListGetFile(BListe,0)) = 0 then
		if len(Sammlung) = 0 then
			Sammlung = FF_IListGetFile(BListe,0)
		else
			Sammlung = Sammlung & vbNewLine & FF_IListGetFile(BListe,0)
		end if
	else
		if len(DuplikatSammlung) = 0 then
			DuplikatSammlung = FF_IListGetFile(BListe,0)
		else
			DuplikatSammlung = DuplikatSammlung & vbNewLine & FF_IListGetFile(BListe,0)
		end if
		anzDbl = anzDbl +1
		anzD = anzD +1
	end if
	FF_IListDeleteIndex BListe,0
loop

'Gesammelte Bilder wieder in die Liste eintragen
SammelArray = split(Sammlung,vbNewLine)
for each element in SammelArray
	FF_IListInsertFile BListe,element,-1
next

FF_IListUpdate BListe

'Protokoll schreiben
ProtText = vbNewLine & "Bilderliste '" & BListe & "'" & vbNewLine
if anzDbl = 0 then 
	ProtText = ProtText & "enthielt keine Duplikate."
elseif anzDbl = 1 then
	ProtText = ProtText & "enthielt folgendes Duplikat:" & vbNewLine & DuplikatSammlung
else
	ProtText = ProtText & "enthielt folgende " & anzDbl & " Duplikate:" & vbNewLine & DuplikatSammlung
end if
ProtText = ProtText & vbNewLine

Set Pdatei = objFS.OpenTextFile(Prot_Datei, ForAppending, true)
Pdatei.Write ProtText
Pdatei.Close

End Sub
'------------------------------------------------------------------------
